Parent: [49388c] (diff)

Child: [17393b] (diff)

Download this file

rclsoff    208 lines (172 with data), 4.8 kB

#!/bin/sh
# @(#$Id: rclsoff,v 1.12 2008-10-08 08:27:34 dockes Exp $  (C) 2004 J.F.Dockes
# Parts taken from Estraier:
#================================================================
# Estraier: a personal full-text search system
# Copyright (C) 2003-2004 Mikio Hirabayashi
#================================================================
#================================================================
# rclsoff
# Extract text from an openoffice/soffice file
#
#================================================================

# set variables
LANG=C ; export LANG
LC_ALL=C ; export LC_ALL
progname="rclsoff"
filetype=openoffice






#RECFILTCOMMONCODE
##############################################################################
# !! Leave the previous line unmodified!! Code imported from the
# recfiltcommon file

# Utility code common to all shell filters. This could be sourced at run
# time, but it's slightly more efficient to include the code in the
# filters at build time (with a sed script).

# Describe error in a way that can be interpreted by our caller
senderror()
{
    echo RECFILTERROR $*
    # Also alert on stderr just in case
    echo ":2:$progname::: $*" 1>&2
    exit 1
}

iscmd()
{
    cmd=$1
    case $cmd in
    */*)
	if test -x $cmd -a ! -d $cmd ; then return 0; else return 1; fi ;;
    *)
      oldifs=$IFS; IFS=":"; set -- $PATH; IFS=$oldifs
      for d in $*;do test -x $d/$cmd -a ! -d $d/$cmd && return 0;done
      return 1 ;;
    esac
}

checkcmds()
{
    for cmd in $*;do
      if iscmd $cmd 
      then 
        a=1
      else 
        senderror HELPERNOTFOUND $cmd
      fi
    done
}

# show help message
if test $# -ne 1 -o "$1" = "--help" 
then
  echo "Convert a $filetype file to HTML text for Recoll indexing."
  echo "Usage: $progname [infile]"
  exit 1
fi

infile="$1"

# check the input file existence (may be '-' for stdin)
if test "X$infile" != X- -a ! -f "$infile"
then
  senderror INPUTNOSUCHFILE "$infile"
fi

# protect access to our temp files and directories
umask 77

##############################################################################
# !! Leave the following line unmodified !
#ENDRECFILTCOMMONCODE

checkcmds awk iconv unzip

# We need a temporary directory
if test z"$RECOLL_TMPDIR" != z; then
   ttdir=$RECOLL_TMPDIR
elif test z"$TMPDIR" != z ; then
   ttdir=$TMPDIR
else
   ttdir=/tmp
fi
tmpdir=$ttdir/rclsoff_tmp$$
mkdir $tmpdir || exit 1
mkdir $tmpdir/rclsofftmp || exit 1

cleanup()
{
    # Note that we're using a constant part (rclsofftmp), that hopefully
    # guarantees that we can't do big mistakes here.
    rm -rf $tmpdir/rclsofftmp
    rmdir $tmpdir
}
    
trap cleanup EXIT HUP QUIT INT TERM

# Unzip the input file and change to the unzipped directory
unzip -q -d $tmpdir/rclsofftmp "$infile"
cd $tmpdir/rclsofftmp

# Note: there can be newlines inside the description field, we don't want
# them...
descsedprog='/<dc:description>/,/<\/dc:description>/{
s!.*<dc:description>!!
s!</dc:description>.*!!
H
${
g
s/\n/ /g
p
}
}
'
description=`sed -n -e "$descsedprog" meta.xml`
#echo description "$description"

# Takes tag name as parameter and creates sed program to extract single
# line meta tags values.
setmetasedprog() {
metasedprog="s/\"/'/g"'
/.*<'"$1"'>\([^<]*\).*/s//\1/p
'
}

setmetasedprog dc:subject
subject=`sed -n -e "$metasedprog" meta.xml`
#echo subject: $subject

setmetasedprog dc:title
title=`sed -n -e "$metasedprog" meta.xml`
#echo title: $title

setmetasedprog meta:keyword
keywords=`sed -n -e "$metasedprog" meta.xml`
#echo keywords: $keywords

setmetasedprog dc:creator
creator=`sed -n -e "$metasedprog" meta.xml`
#echo creator: $creator

# Note: next expr inserts a newline at each end of paragraph (for preview)
content="`sed -e 's!</text:p>!\\
!g' -e 's/<[^>]*>/ /g' < content.xml`"

#echo content "$content"

# output the result
echo '<html><head>'
echo '<title>' "$title" '</title>'
echo '<meta http-equiv="Content-Type" content="text/html;charset=UTF-8">'
echo '<meta name="description" content="' "$description $subject" '">'
echo '<meta name="keywords" content="' "$keywords" '">'
echo '<meta name="author" content="' "$creator" '">'
echo '</head><body><p>'

# The strange 'BEGIN' setup is to prevent 'file' from thinking this file
# is an awk program
echo "$content" | sed -e "s/&apos;/'/g" -e 's/&quot;/"/g' |\
awk 'BEGIN'\
' {
  cont = ""
}
{
    $0 = cont $0
    cont = ""

    if ($0 ~ /[­-]$/) {
      # Note : soft-hyphen is iso8859 0xad
      # Break at last whitespace
      match($0, "[ \t][^ \t]+$")
      line = substr($0, 0, RSTART)
      cont = substr($0, RSTART, RLENGTH-1)
      $0 = line
    }

    if($0 == "\f") {
        print "</p>\n<hr>\n<p>"
        next
    } 

    print $0 "<br>"
}
END {
    printf("</p></body></html>\n");
}' | iconv -f UTF-8 -t UTF-8 -c -s 

cd /
# exit normally
exit 0